// The color list test.
//
// The frame has a private class to implement the listener (jubo 020815)

import java.awt.*;
import javax.swing.*;
import javax.swing.event.*;

public class ColorListFrame extends JFrame
{
   private JList colorList;
   private Container container;         // to hold the content pane
 
   private String colorNames[] = { "Black", "Blue", "Cyan", 
      "Dark Gray", "Gray", "Green", "Light Gray", "Magenta",
      "Orange", "Pink", "Red", "White", "Yellow" };

   private Color colors[] = { Color.black, Color.blue, 
      Color.cyan, Color.darkGray, Color.gray, Color.green,
      Color.lightGray, Color.magenta, Color.orange, Color.pink,
      Color.red, Color.white, Color.yellow };

   // set up GUI
   public ColorListFrame()
   {
      setTitle ("List Test");
      setDefaultCloseOperation (JFrame.EXIT_ON_CLOSE);

      // get content pane and set its layout
      container = getContentPane();
      container.setLayout (new FlowLayout());

      // create a list with items in colorNames array
      colorList = new JList (colorNames);
      colorList.setVisibleRowCount(5);
      
      // do not allow multiple selections
      colorList.setSelectionMode(
         ListSelectionModel.SINGLE_SELECTION );

      // add a JScrollPane containing JList to content pane
      container.add (new JScrollPane (colorList));

      // add a listener which handles events
      colorList.addListSelectionListener (new ColorSelectionListener());

      setSize (350, 150);
   }

   private class ColorSelectionListener implements ListSelectionListener
   {
      // event handler
      public void valueChanged (ListSelectionEvent event)
      {
         container.setBackground (colors[colorList.getSelectedIndex()]);
      }
   }; // end private class ColorSelectionListener
}
