//*******************************************************************
//
//   Fahrenheit.java
//
//   History:
//      Original from the Lewis/Loftus textbook
//      020815 Added main method to make it to an application (jubo)
//
//*******************************************************************

import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class Fahrenheit2 extends Applet
{
   private Label title = new Label ("Fahrenheit to Celcius Converter");
   private Label question = new Label ("Enter Fahrenheit:");
   private Label answer = new Label ("Temperature in Celcius:");

   private TextField fahrenheit = new TextField (5);
   private Label celcius = new Label ("N/A");
   private TextArea log = new TextArea (5, 20);

   private Fahrenheit2_Listener listener = new Fahrenheit2_Listener (this);


   public void init()
   {
      fahrenheit.addActionListener (listener);

      log.setEditable (false);

      add (title);
      add (question);
      add (fahrenheit);
      add (answer);
      add (celcius);
      add (log);

      resize (200, 200);
   }

   //===========================================================
   //  Performs the conversion and displays it in the label
   //  and log.
   //===========================================================
   public void convert()
   {
      int fahrenheit_temperature, celcius_temperature;
      String text = fahrenheit.getText();

      fahrenheit_temperature = Integer.parseInt (text);
      celcius_temperature = (fahrenheit_temperature-32)*5/9;

      celcius.setText (Integer.toString (celcius_temperature));
      log.append (text + " converts to " + celcius.getText() + "\n");
   }


   // Main method
   public static void main (String args[])
   {
      // create a top level container
      JFrame applicationWindow = new JFrame ("Fahrenheit Application");
    
      // set window close operation
      applicationWindow.setDefaultCloseOperation (JFrame.EXIT_ON_CLOSE);

      // create an applet object
      Fahrenheit2 theApplet = new Fahrenheit2();

      // add the applet to the application windows content pane
      applicationWindow.getContentPane().add (theApplet);

      // initialize and start applet
      theApplet.init();
      theApplet.start();

      // set suitable size
      applicationWindow.setSize (200, 250);
      applicationWindow.setLocation (400, 200);
      applicationWindow.setVisible (true);
   }
}


class Fahrenheit2_Listener implements ActionListener
{
   private Fahrenheit2 applet;   // the source of events

   public Fahrenheit2_Listener (Fahrenheit2 listening_applet)
   {
      applet = listening_applet;
   }

   public void actionPerformed (ActionEvent action)
   {
      applet.convert();   // call back applet to do conversion
   } 
}
